<?php
/*
Plugin Name: Plugin Downloads
Plugin URI: http://wordpress.designpraxis.at
Description: Shows your plugins hosted on http://svn.wp-plugins.org/ and summarizes the download statistics
Version: 1.0
Author: Roland Rust
Author URI: http://wordpress.designpraxis.at
*/

add_action('init', 'dprx_pldl_init_locale',98);
function dprx_pldl_init_locale() {
	$locale = get_locale();
	$mofile = dirname(__FILE__) . "/locale/".$locale.".mo";
	load_textdomain('dprx_pldl', $mofile);
}

add_action('admin_menu', 'dprx_pldl_add_admin_pages');
function dprx_pldl_add_admin_pages() {
	add_submenu_page('index.php', 'Plugin Downloads', 'Plugin Downloads', 10, __FILE__, 'dprx_pldl_manage_page');
}

/* options are deleted in case of plugin deactivation */
add_action('deactivate_plugin-downloads/plugin-downloads.php', 'dprx_pldl_deactivate');
function dprx_pldl_deactivate() {
	delete_option("dprx_pldl_wporguser");
	delete_option("dprx_pldl_refresh");
	delete_option("dprx_pldl_cache");
	delete_option("dprx_pldl_sort");
	delete_option("dprx_pldl_sortorder");
}

wp_enqueue_script('prototype');
/* This is a workaround for WordPress bug http://trac.wordpress.org/browser/trunk/wp-admin/admin-header.php?rev=5640 */
if (eregi("plugin-downloads",$_GET['page'])) {
add_action('admin_print_scripts', 'dprx_pldl_loadjs');
}
function dprx_pldl_loadjs() {
	?>	
	<script type="text/javascript">
	function dprx_pldl_js() {
		dprxu = new Ajax.Updater(
		'dprx_plugindownloadsdiv',
		'<?php bloginfo("wpurl"); ?>/wp-admin/index.php?page=<?php echo $_POST['page']; ?>',
			{method: 'get', 
			 parameters:'dprx_pldl_ajax=1',
			 evalScripts: true}
		);
	}
	</script>
	<?php
}
	
/* a reccurence has to be added to the cron_schedules array */
add_filter('cron_schedules', 'dprx_pldl_more_reccurences');
function dprx_pldl_more_reccurences($recc) {
	$refresh = get_option("dprx_pldl_refresh");
	if (empty($refresh)) {
		return $recc;
	} else {
		$refresh = $refresh*3600;
	}
	$recc['dprx_pldl_recc'] = array('interval' => $refresh, 'display' => 'Plugin Downloads Schedule');
	return $recc;
}
	
/* This is the scheduling hook for our plugin that is triggered by cron */
add_action('dprx_pldl_hook','dprx_pldl_trigger_schedule');
function dprx_pldl_trigger_schedule() {
	dprx_pldl_parser();
}
	
	/* Schedules are activated and deactivated */
add_action('init', 'dprx_pldl_setoptions');
function dprx_pldl_setoptions() {
	if (!empty($_POST['dprx_pldl_wporguser'])) {
		update_option("dprx_pldl_wporguser",$_POST['dprx_pldl_wporguser']);
		if (!empty($_POST['dprx_pldl_refresh'])) {
			$timestamp = wp_next_scheduled('dprx_pldl_hook', array());
			/* This is where the event gets unscheduled */
			wp_unschedule_event($timestamp, "dprx_pldl_hook", array());
	
			update_option("dprx_pldl_refresh",$_POST['dprx_pldl_refresh']);
			$refresh = get_option("dprx_pldl_refresh");
			$refresh = $refresh*3600;
			/* This is where the actual recurring event is scheduled */
			if (!wp_next_scheduled('dprx_pldl_hook', array())) {
				wp_schedule_event(time()+$refresh, "dprx_pldl_recc", "dprx_pldl_hook", array());
			}
		}
		dprx_pldl_parser();
	}
}

function dprx_pldl_update_button() {
	?>
	<p style="float:left">
	<input type="button" class="button" value="<?php _e("Refresh Cache Now","dprx_pldl"); ?>" onclick="
	document.getElementById('dprx_plugindownloadsdiv').innerHTML='<img src=<?php bloginfo("url"); ?>/wp-content/plugins/backupwordpress/images/loading.gif /> <?php _e("Retrieving Data. Please wait."); ?>';
	new Ajax.Updater(
	'dprx_plugindownloadsdiv',
	'<?php bloginfo("wpurl"); ?>/wp-admin/index.php?page=<?php echo $_POST['page']; ?>',
		{method: 'get', 
			parameters:'dprx_pldldo_ajax=1'}
	);" />
	<?php
	$next = wp_next_scheduled('dprx_pldl_hook', array());
	_e("Next automatic refresh:","dprx_pldl");
	if (!empty($next)) {
		echo " ".date(get_option('date_format'),$next)." ".date("H:i",$next);		
	} else {
		echo " ";
		_e("no schedule set","dprx_pldl");
	}
	?>
	</p>
	<?php
}

function dprx_pldl_settings_form() {
	?>
	<form method="post" action="<?php bloginfo("url"); ?>/wp-admin/index.php?page=plugin-downloads/plugin-downloads.php">
	<p style="float:right">
	<?php _e("Yor WordPress.org username","dprx_pldl"); ?>: <input size="8" type="text" value="<?php echo get_option("dprx_pldl_wporguser"); ?>" name="dprx_pldl_wporguser" id="dprx_pldl_wporguser" />
	<?php _e("Refresh every:","dprx_pldl"); ?> <input size="3" type="text" value="<?php echo get_option("dprx_pldl_refresh"); ?>" name="dprx_pldl_refresh" id="dprx_pldl_refresh" /> <?php _e("hours","dprx_pldl"); ?>
	<input type="submit" class="button" value="<?php _e("Save","dprx_pldl"); ?>"  />
	</p>
	</form>
	<?php
}
	
function dprx_pldl_display_sum() {
	echo dprx_pldl_get_sum();
}
	
function dprx_pldl_get_sum() {
	$data = get_option("dprx_pldl_cache");
	$sum = 0;
	if (!is_array($data)) { return; }
	foreach ($data as $d) { $sum = $sum + $d['downloads']; }
	return $sum;
}


function dprx_pldl_display_cache() {
	if (!empty($_POST['sort'])) {
		update_option("dprx_pldl_sort",$_POST['sort']);
	}
	
	if ($_POST['sortorder'] == "SORT_DESC") {
		update_option("dprx_pldl_sortorder","SORT_ASC");
	} elseif ($_POST['sortorder'] == "SORT_ASC") {
		update_option("dprx_pldl_sortorder","SORT_DESC");
	}
	
	
	$data = get_option("dprx_pldl_cache");
	if ((count($data) < 1) || !is_array($data)) {
	 	 _e("Error. Could not find that profile.","dprx_pldl"); return;
	}
	foreach ($data as $key => $row) {
		$sort = get_option("dprx_pldl_sort");
		if (empty($sort)) { $sort = "downloads"; }
		$dl[$key]  = $row[$sort];
	}
	$sortorder = get_option("dprx_pldl_sortorder");
	if ($sortorder == "SORT_DESC") {
		array_multisort($dl, SORT_ASC, $data);
	} else {
		array_multisort($dl, SORT_DESC, $data);
	}
	
	?>
	<table class="widefat" id="bkpwp_manage_backups_table">
		<thead>
		<tr>
			<th scope="col"><a href="<?php bloginfo("url"); ?><?php echo $_SERVER['REQUEST_URI']; ?>&amp;sort=title&amp;sortorder=<?php echo get_option("dprx_pldl_sortorder"); ?>"><?php _e("Title","dprx_pldl"); ?></a></th>
			<th scope="col"><?php _e("Version","dprx_pldl"); ?></th>
			<th scope="col"><a href="<?php bloginfo("url"); ?><?php echo $_SERVER['REQUEST_URI']; ?>&amp;sort=updated&amp;sortorder=<?php echo get_option("dprx_pldl_sortorder"); ?>"><?php _e("Updated","dprx_pldl"); ?></a></th>
			<th scope="col"><a href="<?php bloginfo("url"); ?><?php echo $_SERVER['REQUEST_URI']; ?>&amp;sort=downloads&amp;sortorder=<?php echo get_option("dprx_pldl_sortorder"); ?>"><?php _e("Downloads","dprx_pldl"); ?></a></th>
		</tr>
		</thead>
		<tbody id="the-list">
		<?php
		$sum = 0;
		foreach ($data as $d) {
			?>
			<tr>
				<td><a href="<?php echo $d['url']; ?>statistics/"><?php echo $d['title']; ?></a></td>
				<td><?php echo $d['version']; ?></td>
				<td><?php echo date(get_option('date_format'),strtotime($d['updated'])); ?></td>
				<td><?php echo $d['downloads']; $sum = $sum + $d['downloads']; ?></td>
			</tr>
		<?php
		}
		?>
		<tr>
			<th scope="col"></th>
			<th scope="col"></th>
			<th scope="col"></th>
			<th scope="col"><?php echo $sum; ?></th>
		</tr>
		</tbody>
	</table>
	<?php
}

function dprx_pldl_parser() {
	$user = get_option("dprx_pldl_wporguser");
	//snoopy action
	$uri = "http://wordpress.org/extend/plugins/profile/".$user;
	require_once (ABSPATH . WPINC . '/class-snoopy.php');
	$client = new Snoopy();
	@$client->fetch($uri);
	$data = $client->results;
	//preg_match ("/<div id=\"prevclos-".$title."\">([^`]*?)<\/div>/", $match, $temp) 
	preg_match_all("/<div class=\"plugin-block\">([^`]*?)<\/div>/", $data, $m);
	
	// parser starts
	$stripped = "";
	foreach($m[0] as $d) {
		preg_match_all ("/a[\s]+[^>]*?href[\s]?=[\s\"\']+(.*?)[\"\']+.*?>"."([^<]+|.*?)?<\/a>/", $d, $matches );
		$stripped .= $matches[1][0]."\n";
		$stripped .= strip_tags($d);
	}
	$trimmed = explode("\n",$stripped);
	$final = array();
	$nextkey = 1; $i=0;
	foreach($trimmed as $t) {
		$t = trim($t);
		if (!empty($t)) {
			if ($i == 0) { $param = "url"; }
			if ($i == 1) { $param = "title"; }
			if ($i == 2) { $param = "description"; }
			if ($i == 3) { $param = "version"; $t = eregi_replace("Version ","",$t);  }
			if ($i == 4) { $param = "updated"; $t = eregi_replace("updated ","",$t);  }
			if ($i == 5) { $param = "downloads"; $t = eregi_replace("downloads ","",$t); $t = eregi_replace(",","",$t); }
			if (eregi("Rating",$t)) {
				$final[] = $plugin;
				$i=0;
			} else {
				$plugin[$param] = $t;
				$i++;
			}
		}
	}
	// end parser
	update_option("dprx_pldl_cache",$final);
	update_option("dprx_pldl_cache_timestamp",time());
	// for editing the parser code
	/*
	echo "<pre>";
	print_r($final);
	echo "</pre>";
	*/
}

add_action('init', 'dprx_pldl_do',99);
function dprx_pldl_do() {
	if (!empty($_GET['dprx_pldldo_ajax'])) {
		dprx_pldl_parser();
		dprx_pldl_display_cache();
		exit;
	}
}

function dprx_pldl_manage_page() {
	?>
	<div class=wrap>
		<h2><?php _e('Plugin Downloads') ?></h2>
		<?php
		?><?php 
		$user = get_option("dprx_pldl_wporguser");
		if (!empty($user)) {
		dprx_pldl_update_button();
		}
		else {
		?>
		<p style="float:left">
		<?php _e("Please set your WordPress.org's username. Leave blank the Refresh field to disable automatic refresh of the list.","dprx_pldl"); ?>.
		</p>
		<?php
		}
		dprx_pldl_settings_form();
		?>
		<p style="clear:both">
		<div id="dprx_plugindownloadsdiv">
		<?php
		if (!empty($user)) {
			$time = get_option("dprx_pldl_cache_timestamp");
			?>
			<?php _e("The following Data was retrieved from the Cache","dprx_pldl"); ?>.
			<?php _e("Last Cache Update","dprx_pldl"); ?>: <?php echo date(get_option('date_format'),$time)." ".date("H:i:s",$time); ?>
			<?php
			// retrieve cache
			dprx_pldl_display_cache();
		?>
		The Template Tag <b>&lt;? dprx_pldl_display_sum(); ?&gt;</b> <?php _e("displays","dprx_pldl"); ?>: <b><?php dprx_pldl_display_sum(); ?></b>
		<?php } ?>
		</div>
		</p>
	</div>
	<div class="wrap">
		<p>
		<?php _e("Running into Troubles? Features to suggest?","dprx_pldl"); ?>
		<a href="http://wordpress.designpraxis.at/">
		<?php _e("Drop me a line","dprx_pldl"); ?> &raquo;
		</a>
		</p>
		<div style="display: block; height:30px;">
			<div style="float:left; font-size: 16px; padding:5px 5px 5px 0;">
			<?php _e("Do you like this Plugin?","dprx_pldl"); ?>
			<?php _e("Consider to","dprx_pldl"); ?>
			</div>
			<div style="float:left;">
			<form action="https://www.paypal.com/cgi-bin/webscr" method="post">
			<input type="hidden" name="cmd" value="_xclick">
			<input type="hidden" name="business" value="rol@rm-r.at">
			<input type="hidden" name="no_shipping" value="0">
			<input type="hidden" name="no_note" value="1">
			<input type="hidden" name="currency_code" value="EUR">
			<input type="hidden" name="tax" value="0">
			<input type="hidden" name="lc" value="AT">
			<input type="hidden" name="bn" value="PP-DonationsBF">
			<input type="image" src="https://www.paypal.com/en_US/i/btn/x-click-but21.gif" border="0" name="submit" alt="Please donate via PayPal!">
			<img alt="" border="0" src="https://www.paypal.com/en_US/i/scr/pixel.gif" width="1" height="1">
			</form>
			</div>
		</div>
	</div>
	<?php
}
?>